/* cmdvme
   use /dev/nbbqvio
*/

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>

#include "nbbqvio-i.h"

#define TIMEOUT 0x2000

int main(int argc, char *argv[]){
  unsigned long addr,lval,i,j;
  unsigned short sval,wval,ro=0,wo=0;
  int dn = 0;
  if(argc < 4){
    printf("cmdvmen c -[wr/lr/ww/lw/or/ow/on] addr [val]\n");
    printf("cmdvmen c -am val\n");
    exit(0);
  }else{
    dn = atoi(argv[1]);
    init_nbbqvio_i(dn);
    if(strcmp(argv[2],"-wr") == 0){
      addr = strtol(argv[3],NULL,0);
      sval = vme_read16_i(addr,dn);
      printf("%04x\n",sval);
    }else if(strcmp(argv[2],"-lr") == 0){
      addr = strtol(argv[3],NULL,0);
      lval = vme_read32_i(addr,dn);
      printf("%08lx\n",lval);
    }else if(strcmp(argv[2],"-ww") == 0){
      addr = strtol(argv[3],NULL,0);
      sval = strtol(argv[4],NULL,0);
      vme_write16_i(addr,sval,dn);
    }else if(strcmp(argv[2],"-lw") == 0){
      addr = strtol(argv[3],NULL,0);
      lval = strtol(argv[4],NULL,0);
      vme_write32_i(addr,lval,dn);
    }else if(strcmp(argv[2],"-am") == 0){
      lval = strtol(argv[3],NULL,0);
      vme_amsr_i(lval,dn);
    }else if(strcmp(argv[2],"-or") == 0){
      addr = strtol(argv[3],NULL,0);
      sval = strtol(argv[4],NULL,0);
      wval = strtol(argv[5],NULL,0);
      if(wval == 0 || wval > 8){
	wval = 1;
      }
      i=0;
      while(wo !=0x02 && i<TIMEOUT){
	wo = vme_read16_i(addr+0x50,dn);
	i++;
      }
      if(i<TIMEOUT){
	usleep(10);
	vme_write16_i(addr+0x52,sval,dn);
	for(j=0;j<wval;j++){
	  i=0;
	  while(ro !=0x01 && i<TIMEOUT){
	    ro = vme_read16_i(addr+0x50,dn);
	    i++;
	  }
	  if(i<TIMEOUT){
	    usleep(10);
	    sval = vme_read16_i(addr+0x52,dn);
	    printf("%x\n",sval);
	  }else{
	    printf("Time out in read ok.\n");
	  }
	}
      }else{
	printf("Time out in write ok.\n");
      }
    }else if(strcmp(argv[2],"-ow") == 0){
      addr = strtol(argv[3],NULL,0);
      sval = strtol(argv[4],NULL,0);
      wval = strtol(argv[5],NULL,0);
      i=0;
      while(wo !=0x02 && i<TIMEOUT){
	wo = vme_read16_i(addr+0x50,dn);
	i++;
      }
      if(i<TIMEOUT){
	usleep(10);
	vme_write16_i(addr+0x52,sval,dn);
	i=0;
	while(wo !=0x02 && i<TIMEOUT){
	  wo = vme_read16_i(addr+0x50,dn);
	  i++;
	}
	if(i<TIMEOUT){
	  usleep(10);
	  vme_write16_i(addr+0x52,wval,dn);
	  printf("%x\n",sval);
	}else{
	  printf("Time out in write ok.\n");
	}
      }else{
	printf("Time out in write ok.\n");
      }
    }else if(strcmp(argv[2],"-on") == 0){
      addr = strtol(argv[3],NULL,0);
      sval = strtol(argv[4],NULL,0);
      i=0;
      while(wo !=0x02 && i<TIMEOUT){
	wo = vme_read16_i(addr+0x50,dn);
	i++;
      }
      if(i<TIMEOUT){
	usleep(10);
	vme_write16_i(addr+0x52,sval,dn);
      }else{
      printf("Time out in write ok.\n");
    }
    }else{
      printf("cmdvme dn -[wr/lr/ww/lw/or/ow] addr [val]\n");
      printf("cmdvme dn -am val\n");
    }
    release_nbbqvio_i();
  }


  return 0;
}
