/* cmdvme2
   use /dev/nbbqvio2
*/

#include <sys/types.h>
#include <sys/stat.h>
#include <sys/ioctl.h>
#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <stdlib.h>
#include <fcntl.h>

#include "nbbqvio2.h"

#define TIMEOUT 0x2000

int main(int argc, char *argv[]){
  unsigned long addr,lval,i,j;
  unsigned short sval,wval,ro=0,wo=0;

  if(argc < 3){
    printf("cmdvme2 -[wr/lr/ww/lw/or/ow/on] addr [val]\n");
    printf("cmdvme2 -am val\n");
    exit(0);
  }else{
    if(init_nbbqvio()){
      exit(0);
    }
    if(strcmp(argv[1],"-wr") == 0){
      addr = strtol(argv[2],NULL,0);
      sval = vme_read16(addr);
      printf("%04x\n",sval);
    }else if(strcmp(argv[1],"-lr") == 0){
      addr = strtol(argv[2],NULL,0);
      lval = vme_read32(addr);
      printf("%08lx\n",lval);
    }else if(strcmp(argv[1],"-ww") == 0){
      addr = strtol(argv[2],NULL,0);
      sval = strtol(argv[3],NULL,0);
      vme_write16(addr,sval);
    }else if(strcmp(argv[1],"-lw") == 0){
      addr = strtol(argv[2],NULL,0);
      lval = strtol(argv[3],NULL,0);
      vme_write32(addr,lval);
    }else if(strcmp(argv[1],"-am") == 0){
      addr = strtol(argv[2],NULL,0);
      lval = strtol(argv[3],NULL,0);
    }else if(strcmp(argv[1],"-or") == 0){
      addr = strtol(argv[2],NULL,0);
      sval = strtol(argv[3],NULL,0);
      wval = strtol(argv[4],NULL,0);
      if(wval == 0 || wval > 8){
	wval = 1;
      }
      i=0;
      while(wo !=0x02 && i<TIMEOUT){
	wo = vme_read16(addr+0x50);
	i++;
      }
      if(i<TIMEOUT){
	usleep(10);
	vme_write16(addr+0x52,sval);
	for(j=0;j<wval;j++){
	  i=0;
	  while(ro !=0x01 && i<TIMEOUT){
	    ro = vme_read16(addr+0x50);
	    i++;
	  }
	  if(i<TIMEOUT){
	    usleep(10);
	    sval = vme_read16(addr+0x52);
	    printf("%x\n",sval);
	  }else{
	    printf("Time out in read ok.\n");
	  }
	}
      }else{
	printf("Time out in write ok.\n");
      }
    }else if(strcmp(argv[1],"-ow") == 0){
      addr = strtol(argv[2],NULL,0);
      sval = strtol(argv[3],NULL,0);
      wval = strtol(argv[4],NULL,0);
      i=0;
      while(wo !=0x02 && i<TIMEOUT){
	wo = vme_read16(addr+0x50);
	i++;
      }
      if(i<TIMEOUT){
	usleep(10);
	vme_write16(addr+0x52,sval);
	i=0;
	while(wo !=0x02 && i<TIMEOUT){
	  wo = vme_read16(addr+0x50);
	  i++;
	}
	if(i<TIMEOUT){
	  usleep(10);
	  vme_write16(addr+0x52,wval);
	  printf("%x\n",sval);
	}else{
	  printf("Time out in write ok.\n");
	}
      }else{
	printf("Time out in write ok.\n");
      }
    }else if(strcmp(argv[1],"-on") == 0){
      addr = strtol(argv[2],NULL,0);
      sval = strtol(argv[3],NULL,0);
      i=0;
      while(wo !=0x02 && i<TIMEOUT){
	wo = vme_read16(addr+0x50);
	i++;
      }
      if(i<TIMEOUT){
	usleep(10);
	vme_write16(addr+0x52,sval);
      }else{
      printf("Time out in write ok.\n");
    }
    }else{
      printf("cmdvme -[wr/lr/ww/lw/or/ow] addr [val]\n");
      printf("cmdvme -am val\n");
    }
    release_nbbqvio();
  }


  return 0;
}
